Public Class FrmDoubleDeclining


    Private Sub btnDepreciate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDepreciate.Click
        Dim Cost As Double
        Dim Salvage As Double
        Dim Lifetime As Integer
        Dim i As Integer
        Dim value As Double
        Dim depreciation As Double

        'get cost from textbox, exit if no good
        Try
            Cost = txtCost.Text
        Catch ex As Exception
            MsgBox("Please enter a number for the cost.")
            Exit Sub
        End Try

        'get salvage from textbox, exit if no good
        Try
            Salvage = txtSalvage.Text
        Catch ex As Exception
            MsgBox("Please enter a number for the cost.")
            Exit Sub
        End Try

        'get lifetime from numericupdown
        Lifetime = nudLife.Value

        'guard against salvage being greater than cost
        If Salvage > Cost Then
            MsgBox("The salvage value must be less than the cost.")
            Exit Sub
        End If

        'clear out any previous reulsts
        lstDepreciation.Items.Clear()

        'value begins at cost
        value = Cost

        'Loop through lifetime
        For i = 1 To Lifetime
            'calculate double declining depreciation
            depreciation = value * 2 / Lifetime

            'subtract depreciation from value
            value -= depreciation


            If value > Salvage Then
                lstDepreciation.Items.Add("After " & i & " year(s), the item is depreciated by " & Format(depreciation, "Currency") & " and has a value of " & Format(value, "Currency"))
            Else
                'fix if value dips below salvage
                depreciation += value - Salvage
                value = Salvage
                lstDepreciation.Items.Add("After " & i & " year(s), the item is depreciated by " & Format(depreciation, "Currency") & " and has a value of " & Format(value, "Currency"))
                Exit For
            End If
        Next
    End Sub

    '****************************************************************************
    'clear out results if user changes cost
    Private Sub txtCost_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCost.TextChanged
        lstDepreciation.Items.Clear()
    End Sub

    '****************************************************************************
    'clear out results if user changes salvage
    Private Sub txtSalvage_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSalvage.TextChanged
        lstDepreciation.Items.Clear()
    End Sub

    '****************************************************************************
    'clear out results if user changes lifetime 
    Private Sub nudLife_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudLife.ValueChanged
        lstDepreciation.Items.Clear()
    End Sub
End Class
